#include "GeoRotation.h"

CGeoRotation::CGeoRotation(void)
{
}

CGeoRotation::~CGeoRotation(void)
{
}


/// Transform the given point.
void CGeoRotation::Transform(double& dx, double& dy) const
{
	Rotate(dy, dx);
}


/// Inverse transform the given point.
void CGeoRotation::InverseTransform(double& dx, double& dy) const
{
	InverseRotate(dy, dx);
}




void CGeoRotation::SetOrigin(double dLatDegrees, double dLongDegrees)
{
	m_Origin.SetLatDegrees(dLatDegrees);
	m_Origin.SetLongDegrees(dLongDegrees);
}

void CGeoRotation::Rotate(double& dLatDegrees, double& dLongDegrees) const
{
	CGeoLatLong rLatLong;
	rLatLong.SetLatDegrees(dLatDegrees);
	rLatLong.SetLongDegrees(dLongDegrees);
	
	Rotate(rLatLong);

	dLatDegrees = rLatLong.GetLatDegrees();
	dLongDegrees = rLatLong.GetLongDegrees();

}

void CGeoRotation::Rotate(CGeoLatLong& rLatLong) const
{
	double dRange;
	double dHeading;
	m_Origin.RangeAndHeading(rLatLong, dRange, dHeading);

	rLatLong.Set(dHeading, dRange, CGeoLatLong());

}

void CGeoRotation::InverseRotate(double& dLatDegrees, double& dLongDegrees) const
{
	CGeoLatLong rLatLong;
	rLatLong.SetLatDegrees(dLatDegrees);
	rLatLong.SetLongDegrees(dLongDegrees);
	
	InverseRotate(rLatLong);

	dLatDegrees = rLatLong.GetLatDegrees();
	dLongDegrees = rLatLong.GetLongDegrees();
}


void CGeoRotation::InverseRotate(CGeoLatLong& rLatLong) const
{
	double dRange;
	double dHeading;
	CGeoLatLong().RangeAndHeading(rLatLong, dRange, dHeading);

	rLatLong.Set(dHeading, dRange, m_Origin);

}