/*---------------------------------------------------------------------------
Copyright (C) GeoLib.
This code is used under license from GeoLib (www.geolib.co.uk). This or
any modified versions of this cannot be resold to any other party.
---------------------------------------------------------------------------*/


/**--------------------------------------------------------------------------<BR>
\file SlantRangeHeading.cpp
\brief Implementation file for a CSlantRangeHeading class.

Implementation file for a CSlantRangeHeading class.
<P>---------------------------------------------------------------------------*/




#include "SlantRangeHeading.h"
#include "Geodetic.h"
#include "StdAfx.h"

/**--------------------------------------------------------------------------<BR>
SlantRangeHeading::SlantRangeHeading <BR>
\brief Destructor.
<P>---------------------------------------------------------------------------*/
CSlantRangeHeading::CSlantRangeHeading(void)
{
	SetType(eSlantRangeHeading);
}

/**--------------------------------------------------------------------------<BR>
CSlantRangeHeading::~CSlantRangeHeading <BR>
\brief Destructor.
<P>---------------------------------------------------------------------------*/
CSlantRangeHeading::~CSlantRangeHeading(void)
{
}

/**--------------------------------------------------------------------------<BR>
CSlantRangeHeading::Project <BR>
\brief Project the given lat long to x, y using the input parameters to store the 
result.
<P>---------------------------------------------------------------------------*/
void CSlantRangeHeading::Project(double& dLatY, double& dLongX) const
{
	CLambertAzimuthalEqualArea::Project(dLatY, dLongX);

	dLatY *= conEARTH_RADIUS_METRES;
	dLongX *= conEARTH_RADIUS_METRES;
}



/**--------------------------------------------------------------------------<BR>
CSlantRangeHeading::InverseProject <BR>
\brief Project the given x y to lat long using the input parameters to store the result.	
<P>---------------------------------------------------------------------------*/
void CSlantRangeHeading::InverseProject(double& dLatY, double& dLongX) const
{
	dLatY /= conEARTH_RADIUS_METRES;
	dLongX /= conEARTH_RADIUS_METRES;

	CLambertAzimuthalEqualArea::InverseProject(dLatY, dLongX);
}


