/*---------------------------------------------------------------------------
Copyright (C) GeoLib.
This code is used under license from GeoLib (www.geolib.co.uk). This or
any modified versions of this cannot be resold to any other party.
---------------------------------------------------------------------------*/


/**--------------------------------------------------------------------------<BR>
\file SlantRangeHeading.h
\brief Header file for a SlantRangeHeading class.

Header file for a SlantRangeHeading class which represents the SlantRangeHeading projection.

\class SlantRangeHeading
\brief class which represents the a projection that is defined for each projected point by
the heading from the origin to that point and the slant range.
<P>---------------------------------------------------------------------------*/



#pragma once
#include "projection.h"
#include "LambertAzimuthalEqualArea.h"

#ifdef _PROJ_EXPORTING
	#define PROJ_DECLSPEC		__declspec(dllexport)
#else 
	#ifdef _STATIC
		#define PROJ_DECLSPEC
	#else
		#define PROJ_DECLSPEC		__declspec(dllimport)
	#endif
#endif

class PROJ_DECLSPEC CSlantRangeHeading : public CLambertAzimuthalEqualArea
{
public:
	CSlantRangeHeading(void);

	~CSlantRangeHeading(void);

	// Project the given lat long to x, y using the input parameters to store the result.
	virtual void Project(double& dLatY, double& dLongX) const;

	// Project the given x y to lat long using the input parameters to store the result.	
	virtual void InverseProject(double& dLatY, double& dLongX) const;


};
